/*
 * Author:          Patrick-Christopher Mattulat
 * Co-Author:       Claude Sonnet 4.6 (LLM)
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2021-05-01
 * Changed:         2026-06-23
 *
 * */

#include <gtest/gtest.h>
#include <ls-std/ls-std-core.hpp>
#include <string>

using ls::standard::core::FileOperationException;
using std::string;
using testing::Test;

namespace
{
  class FileOperationExceptionTest : public Test
  {
    public:

      FileOperationExceptionTest() = default;
      ~FileOperationExceptionTest() override = default;
  };

  TEST_F(FileOperationExceptionTest, constructor)
  {
    EXPECT_THROW(
        {
          try
          {
            throw FileOperationException{};
          }
          catch (const FileOperationException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + " thrown - file operation failed!";

            EXPECT_STREQ(expected.c_str(), actual.c_str());
            throw;
          }
        },
        FileOperationException);
  }

  TEST_F(FileOperationExceptionTest, constructor_dedicated_message)
  {
    EXPECT_THROW(
        {
          try
          {
            throw FileOperationException{R"(creating directory "tmp")"};
          }
          catch (const FileOperationException &_exception)
          {
            const string actual = _exception.what();
            const string expected = _exception.getName() + R"( thrown - creating directory "tmp")";

            EXPECT_STREQ(expected.c_str(), actual.c_str());
            throw;
          }
        },
        FileOperationException);
  }

  TEST_F(FileOperationExceptionTest, getName)
  {
    ASSERT_STREQ("FileOperationException", FileOperationException{}.getName().c_str());
  }
}
